/**
 * 
 */
package benchmark.helpClasses;

import java.io.PrintStream;

/**
 * Implements a stopwatch.
 * 
 * @author Sepp Hartung
 * @since 1.3
 * @version 1.0
 */
public class StopWatch
{
	private long beginDate;

	private long endDate;

	public StopWatch()
	{
		this.start();
	}

	private long getTimeDistance()
	{
		long date = this.endDate;
		if (date == 0L)
		{
			date = System.currentTimeMillis();
		}
		return date - this.beginDate;
	}

	public float getTimeInSec()
	{
		return (float) (this.getTimeDistance() / 1000d);
	}

	public void printTime(final String s, final PrintStream p)
	{

		final long dif = this.getTimeDistance();
		if (dif > 70000)
		{
			final long min = dif / 60000;
			p.print(s + min + "min" + String.valueOf((dif % 60000) / 1000) + "s");
		} else if (dif > 20000)
		{
			p.print(s + String.valueOf(dif / 1000) + "s");
		} else
		{
			p.print(s + String.valueOf(dif) + "ms");
		}
		p.flush();
	}

	public void start()
	{
		this.beginDate = System.currentTimeMillis();
	}

	public void start(final String str)
	{
		System.out.println(str);
		this.start();
	}

	public StopWatch stopp()
	{
		this.endDate = System.currentTimeMillis();
		return this;
	}

	public void stopp_Print()
	{
		this.stopp_Print("");
	}

	public void stopp_Print(final String s)
	{
		this.stopp_Print(s, System.out);
	}

	public void stopp_Print(final String s, final PrintStream stream)
	{
		this.stopp();
		this.printTime(s, stream);
	}
}
