package dataStructures;

public class IntTupel implements Comparable<IntTupel>
{
	private final int first;

	private final int hash;

	private final int second;

	public IntTupel(final int first, final int second)
	{
		this.first = Math.min(first, second);
		this.second = Math.max(first, second);
		this.hash = (7 * this.first) + (31 * this.second);
	}

	@Override
	public IntTupel clone()
	{
		return new IntTupel(this.getFirst(), this.getSecond());

	}

	@Override
	public int compareTo(final IntTupel o)
	{
		return o.getSecond() - this.getSecond();
	}

	@Override
	public boolean equals(final Object obj)
	{
		if (!(obj instanceof IntTupel))
			return false;

		final IntTupel t = (IntTupel) obj;
		return (t.first == this.first) && (t.second == this.second);
	}

	public int getFirst()
	{
		return this.first;
	}

	public int getSecond()
	{
		return this.second;
	}

	@Override
	public int hashCode()
	{

		return this.hash;
	}

	@Override
	public String toString()
	{
		return "(" + this.first + "," + this.second + ")";
	}

}
