package distanceFunction;

import java.util.Arrays;

public class SymmetricBooleanArrayDistanceFunction extends SymmetricBooleanDistanceFunction
{
	private final boolean[][] distance;

	private SymmetricBooleanArrayDistanceFunction(final boolean[][] arr)
	{
		super(arr.length + 1);
		this.distance = arr;
	}

	public SymmetricBooleanArrayDistanceFunction(final int n)
	{
		super(n);
		this.distance = new boolean[n - 1][];
		for (int i = n - 1; i > 0; i--)
		{
			this.distance[n - 1 - i] = new boolean[i];
		}
	}

	@Override
	public SymmetricBooleanArrayDistanceFunction clone()
	{
		final boolean[][] copyArr = new boolean[this.distance.length][];
		for (int i = 0; i < copyArr.length; i++)
		{
			copyArr[i] = this.distance[i].clone();
		}
		return new SymmetricBooleanArrayDistanceFunction(copyArr);
	}

	@Override
	boolean getInternal(final int i, final int j)
	{
		return this.distance[i][j];
	}

	@Override
	public int hashCode()
	{
		return Arrays.deepHashCode(this.distance) * this.getNoOfElements();
	}

	@Override
	void setInternal(final int i, final int j, final boolean value)
	{
		this.distance[i][j] = value;
	}
}
