package distanceFunction.random;

import distanceFunction.SymmetricDiscreteDistanceFunction;

/**
 * 
 * @author Sepp Hartung
 * 
 */
public class MergeElements
{
	private MergeElements e1;

	private MergeElements e2;

	int i;

	public MergeElements(final int i)
	{
		this.i = i;
	}

	public MergeElements(final MergeElements e1, final MergeElements e2)
	{
		this.e1 = e1;
		this.e2 = e2;
	}

	public int getIndex()
	{
		return this.i;
	}

	public int setValue(final SymmetricDiscreteDistanceFunction function, final int j, final int value)
	{
		if ((this.e1 != null) && (this.e2 != null))
		{
			int r = this.e1.setValue(function, j, value);
			r += this.e2.setValue(function, j, value);
			return r;
		} else
		{
			final int r = Math.abs(function.get(this.i, j) - value);
			function.set(this.i, j, value);
			return r;
		}
	}

	public int setValue(final SymmetricDiscreteDistanceFunction function, final MergeElements j, final int value)
	{
		if ((this.e1 != null) && (this.e2 != null))
		{
			if ((j.e1 != null) && (j.e2 != null))
			{
				int r = this.e1.setValue(function, j.e1, value);
				r += this.e1.setValue(function, j.e2, value);
				r += this.e2.setValue(function, j.e1, value);
				r += this.e2.setValue(function, j.e2, value);
				return r;
			} else
				return this.setValue(function, j.i, value);
		} else
			return j.setValue(function, this.i, value);
	}
}
