package dataReductionRules;

import distanceFunction.SymmetricDiscreteDistanceFunction;

/**
 * Rule: Delete unaffected nodes.
 * 
 * @author Sepp Hartung
 * @version 1.0
 * 
 */
public class Rule2 extends AdvancedRule
{

	public Rule2(final int interleavingConst)
	{
		super(interleavingConst);
	}

	@Override
	public boolean performReductionRule(final ChangeLogger solver) throws UnsolvableException
	{
		final SymmetricDiscreteDistanceFunction distanceFunction = solver.getDistanceFunction();
		final int[] elements = new int[distanceFunction.getNoOfElements()];
		{// count the occurences of the elements
			for (final int[] conflicts : solver.getConflicts())
			{
				elements[conflicts[0]]++;
				elements[conflicts[1]]++;
				elements[conflicts[2]]++;
			}
		}

		for (int i = 0; i < elements.length; i++)
		{
			if ((elements[i] == 0) && !distanceFunction.isDeletedData(i))
			{
				solver.deleteData(i);
			}
		}
		return false;
	}
}