package dataReductionRules;

/**
 * Interface for DataReductionRules.
 * 
 * @author Sepp Hartung
 * @version 1.0
 * 
 */
public interface RuleInterface
{
	/**
	 * Apply the data reduction rule to a distance function.
	 * 
	 * @param distanceFunction
	 * @return true=rule shrinks something false=otherwise
	 * @throws UnsolvableException
	 */
	boolean performRule(ChangeLogger instance) throws UnsolvableException;
}
