/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dataReductionRules.rule3HelpClasses;

import java.util.BitSet;

/**
 * 
 * @author mrheh
 */
public class CliquePool
{
	private final int capacity;
	private final BitSet free;
	private final int maxElement;

	private final SparseIntegerIdenfitiableSet<Clique> set;

	public CliquePool(final int capacity, final int maxElement)
	{
		this.capacity = capacity;
		this.free = new BitSet(capacity);
		this.maxElement = maxElement;
		this.set = new SparseIntegerIdenfitiableSet<Clique>(capacity);
	}

	public void freeClique(final Clique clique)
	{
		this.set.remove(clique);
		this.free.clear(clique.getNumber());
	}

	public Clique getClique() throws CliquePoolExhausted
	{
		if (this.size() == this.capacity)
			throw new CliquePoolExhausted();
		final int newNumber = this.free.nextClearBit(0);
		this.free.set(newNumber);

		final Clique newClique = new Clique(this.maxElement, newNumber);
		this.set.add(newClique);
		return newClique;
	}

	public SparseIntegerIdenfitiableSet<Clique> getSet()
	{
		return this.set;
	}

	int size()
	{
		return this.set.size();
	}

}
