package dataReductionRules.rule3HelpClasses.deprecated;

import java.util.Iterator;
import java.util.TreeMap;
import java.util.TreeSet;

import org.jgrapht.graph.DefaultEdge;
import org.jgrapht.graph.SimpleGraph;

public class findCCGraph
{

	public static SimpleGraph<TreeSet<Node>, DefaultEdge> ccgraph(final SimpleGraph<Node, DefaultEdge> G)
	{

		final SimpleGraph<TreeSet<Node>, DefaultEdge> CC = new SimpleGraph<TreeSet<Node>, DefaultEdge>(DefaultEdge.class);

		// determine some vertex characters
		// only vertices with the same characters can be twins
		// so far: only vertex degree
		// heuristic to ensure that two vertices are no twins
		Iterator<Node> V = G.vertexSet().iterator();
		while (V.hasNext())
		{
			final Node v = V.next();
			// delete old characters
			v.key.characters.clear();

			// 1st characterisic: degree of the vertex
			final int d = v.G.degreeOf(v);
			v.key.characters.add(d);

			// 2nd characteristic: sum of the vertex indices in the closed
			// neighborhood
			// init with own index
			v.key.characters.add(v.i);

			// 3rd characteristic (only if degree is zero): vertex index
			if (d == 0)
			{
				v.key.characters.add(v.i);
			}
		}

		// compute second characteristic
		final Iterator<DefaultEdge> E = G.edgeSet().iterator();
		while (E.hasNext())
		{
			final DefaultEdge e = E.next();
			final Node u = G.getEdgeSource(e);
			final Node v = G.getEdgeTarget(e);
			v.key.characters.set(1, v.key.characters.get(1) + u.i);
			u.key.characters.set(1, u.key.characters.get(1) + v.i);
		}

		// System.out.println("mit deg");

		// build the TreeMap M
		// - mapping from NodeKey to a set of Nodes, where two Nodes have the
		// same key iff they are
		// twins
		V = G.vertexSet().iterator();
		final TreeMap<NodeKey, TreeSet<Node>> M = new TreeMap<NodeKey, TreeSet<Node>>();
		while (V.hasNext())
		{
			final Node v = V.next();
			if (M.containsKey(v.key))
			{
				M.get(v.key).add(v);
			} else
			{
				M.put(v.key, new TreeSet<Node>());
				M.get(v.key).add(v);
			}
		}

		// System.out.println(M);

		// construct cc graph
		// - add vertices
		Iterator<TreeSet<Node>> X = M.values().iterator();
		while (X.hasNext())
		{
			CC.addVertex(X.next());
		}

		// add edges
		X = M.values().iterator();
		Iterator<TreeSet<Node>> Y;
		while (X.hasNext())
		{
			final TreeSet<Node> c1 = X.next();
			Y = M.values().iterator();
			while (Y.hasNext())
			{
				final TreeSet<Node> c2 = Y.next();
				if ((c1 != c2) && G.containsEdge(c1.first(), c2.first()))
				{
					CC.addEdge(c1, c2);
				}
			}

		}

		return CC;
	}

}
